#include <stdio.h>
#include "numsolve.h"
#include "qcdeqn.h"

/*Functie voor numeriek vinden van wordtels van een vergelijking*/
double rtbis(double (*func)(double,double), double p, double x1, double x2, double xacc)
{
	int j;
	double dx,f,fmid,xmid,rtb;
	f=(*func)(x1,p);
	fmid=(*func)(x2,p);
	if (f*fmid >= 0.0) nrerror("Root must be bracketed for bisection in rtbis");
	rtb = f < 0.0 ? (dx=x2-x1,x1) : (dx=x1-x2,x2);
	for (j=1;j<=JMAX;j++) {
		fmid=(*func)(xmid=rtb+(dx *= 0.5),p);
		if (fmid <= 0.0) rtb=xmid;
		if (fabs(dx) < xacc || fmid == 0.0) return rtb;
		}
	nrerror("Too many bisections in rtbis");
	return 0.0;
}

/*Afbakenen interval voor het zoeken naar een wortel*/
int zbrac(double (*func)(double,double), double p, double *x1, double *x2)
{
	int j;
	double f1,f2;
	if (*x1 == *x2) nrerror("Bad initial range in zbrac");
	f1=(*func)(*x1,p);
	f2=(*func)(*x2,p);
	for (j=1;j<=NTRY;j++) {
		if (f1*f2 < 0.0) return 1;
		if (fabs(f1) < fabs(f2))
			f1=(*func)(*x1 += FACTOR*(*x1-*x2),p);
		else
			f2=(*func)(*x2 += FACTOR*(*x2-*x1),p);
		}
	return 0;
}

/*Aansturen bovenstaande functies om tussen brede intervallen x en y met nauwkeurigheid acc de oplossing van functie *vgl te vinden*/
double vindwortel(double (*vgl)(double,double), double pres, double x, double y, double acc)
{
	double answ;
	int test;
	test=zbrac(&*vgl,pres,&x,&y);
	if(test)
	{
		answ=rtbis(&*vgl,pres,x,y,acc);
	}
	else
	{
		nrerror("Error in zbrac");
		answ=0;
	}
	return answ;
}

double muf(double press)
{
	double mu;
	mu = vindwortel(&mufunc,press,200,10000,0.01);
	return (mu);
}
